]> code.delx.au - dotfiles/blob - .bashrc
bash: Fix PROMPT_COMMAND
[dotfiles] / .bashrc
1 # shellcheck disable=SC1090 disable=SC1091 # -- Can't follow non-constant source
2
3 ###########################
4 # Settings for all shells #
5 ###########################
6
7 # Set umask, depending on the user ID
8 if [ "$(id -un)" = "root" ]; then
9 umask 0022
10 else
11 umask 0007
12 fi
13
14 # Add ~/bin and subdirs to PATH if needed
15 while read -r p; do
16 echo "$PATH" | tr ':' '\n' | grep -qxF "$p" || PATH="${p}:$PATH"
17 done < <(find -L ~/bin -maxdepth 1 -type d 2> /dev/null)
18
19 # Set EMAIL from the freedesktop environment.d
20 if ls ~/.config/environment.d/*.conf &> /dev/null; then
21 eval "$(awk -F= '{print $0 ";export " $1}' ~/.config/environment.d/*.conf)"
22 fi
23
24 # Pick up SSH agent socket
25 if [ -z "$SSH_AUTH_SOCK" ]; then
26 if [ -r ~/.ssh-agent.env ]; then
27 source ~/.ssh-agent.env
28 else
29 SSH_AUTH_SOCK="/run/user/$(id -u)/keyring/ssh"
30 export SSH_AUTH_SOCK
31 fi
32 fi
33
34
35 ###########################
36 # Interactive shells only #
37 ###########################
38
39 if [ -z "${PS1}" ]; then
40 return
41 fi
42
43
44 ################
45 # bash options #
46 ################
47
48 # Bash should check the terminal size after every command terminates
49 shopt -s checkwinsize
50
51 # Don't attempt to tab-complete an empty line
52 shopt -s no_empty_cmd_completion
53
54 # Prevent overwriting existing files on stdout redirection
55 set -o noclobber
56
57 # Better history
58 shopt -s histappend
59 shopt -s cmdhist
60 export HISTCONTROL='erasedups:ignoredups:ignorespace'
61 export HISTSIZE='100000'
62 export HISTTIMEFORMAT='%F %T '
63
64 [ -r /etc/bash_completion ] && source /etc/bash_completion
65
66 ##################
67 # Terminal setup #
68 ##################
69
70 # Disable CTRL-s / CTRL-q
71 stty -ixon
72
73 # hostname:workingdir
74 PROMPT_COMMAND='echo -ne "\\033]0;$(hostname|cut -d. -f1):${PWD/$HOME/\~}\\007"'
75
76 # Use dark background colors in apps like vim
77 export COLORFGBG='15;0'
78
79 #############
80 # Fancy PS1 #
81 #############
82
83 # Revision control status for git, hg, svn
84
85 function find_up_exists {
86 local d="$PWD"
87 while [ -n "$d" ]; do
88 if [ -e "$d/$1" ]; then
89 return 0
90 fi
91 d="${d%/*}"
92 done
93 return 1
94 }
95
96 [ -r /usr/lib/git-core/git-sh-prompt ] && source /usr/lib/git-core/git-sh-prompt
97 [ -r /usr/share/git/completion/git-prompt.sh ] && source /usr/share/git/completion/git-prompt.sh
98 function my_git_ps1 {
99 find_up_exists .git || return
100 GIT_PS1_SHOWDIRTYSTATE=1 \
101 GIT_PS1_SHOWUNTRACKEDFILES=1 \
102 __git_ps1 ' (%s)' 2> /dev/null
103 }
104
105 function my_hg_ps1 {
106 find_up_exists .hg || return
107 local status
108 status="$(hg status | cut -c1 | sort -u | tr -d ' \n')"
109 echo -n " ($status)"
110 }
111
112 function my_svn_ps1 {
113 find_up_exists .svn || return
114 local status
115 status="$(svn status --ignore-externals 2> /dev/null | cut -c1 | sort -u | tr -d ' \n')"
116 [ -n "$status" ] && echo -n " ($s)"
117 }
118
119 # Two line prompt
120 PS1=''
121 PS1="$PS1"'\[\033[01;31m\]\u@\h\[\033[00m\]:\[\033[01;34m\]\w\[\033[00m\]'
122 PS1="$PS1"'\[\033[01;36m\]$(my_git_ps1 ; my_hg_ps1 ; my_svn_ps1)\[\033[00m\]'
123
124 if ! [[ "$TERM" =~ ^screen ]]; then
125 PS1="$PS1"'\n\$ '
126 else
127 # matches with shelltitle in .screenrc
128 PS1="$PS1"'\n\[\033k\033\\\]\$> '
129 fi
130
131
132 #################################
133 # Display return codes on error #
134 #################################
135
136 function print_exit_code {
137 _exit_msg="\\033[01;33mexit code: $?\\033[00m"
138 if [ -z "${BASH_SOURCE[1]}" ]; then
139 echo -e "$_exit_msg"
140 fi
141 unset _exit_msg
142 }
143 trap print_exit_code ERR
144
145
146 ###############
147 # Pager setup #
148 ###############
149
150 export PAGER='less'
151 export LESS='RS'
152
153
154 ################
155 # Editor setup #
156 ################
157
158 if emacsclient --version &> /dev/null; then
159 export ALTERNATE_EDITOR='vim'
160 export EDITOR='emacsclient --tty'
161
162 if [[ "$TERM" == screen* ]]; then
163 alias edit='emacsclient --tty'
164 else
165 alias edit='emacsclient --create-frame --no-wait'
166 fi
167 else
168 export EDITOR='vim'
169 alias edit='vim'
170 fi
171
172
173 ##########################
174 # ls aliases and colours #
175 ##########################
176
177 # GNU ls colours
178 eval "$(TERM=xterm dircolors 2> /dev/null)"
179
180 # BSD ls colours
181 export LSCOLORS="ExFxCxDxBxEGEDABAGACAD"
182
183 # Lets find the ls
184 if ls --color=auto -v &> /dev/null; then
185 alias ls='ls --color=auto -v'
186 elif gls --color=auto -v &> /dev/null; then
187 alias ls='gls --color=auto -v'
188 elif ls -G &> /dev/null; then
189 alias ls='ls -G'
190 else
191 alias ls='ls -F'
192 fi
193 alias ll='ls -hlF'
194 alias la='ls -ha'
195 alias l='ls -halF'
196
197 ##############
198 # ps aliases #
199 ##############
200
201 alias _psresources='ps -wAo pid,user,%cpu,%mem,stat,start,time,args'
202 if [ "$(uname)" = "Linux" ]; then
203 alias pscpu='_psresources --sort -%cpu|less -S'
204 alias psmem='_psresources --sort -%mem|less -S'
205 alias pstree='ps --forest -weo pid,user:16,args --sort start_time|less -S'
206 alias pstime='ps -wAo pid,user,lstart,args --sort start_time|less -S'
207 else
208 alias pscpu='_psresources -r|less -S'
209 alias psmem='_psresources -m|less -S'
210 alias pstime='ps -wAo pid,user,lstart,args|less -S'
211 fi
212
213 #################
214 # Other aliases #
215 #################
216
217 alias f='find . -iname'
218 if echo x | grep -q --color=auto x &> /dev/null; then
219 alias grep='grep --color=auto'
220 fi
221 alias rg='rg -p'
222 alias scp='scp -o ControlPath=none'
223 alias bc='bc -ql'
224 alias watch='watch -n1'
225 alias sudo='sudo ' # ability to use aliases with sudo
226 alias sudosu='sudo su -l -s /bin/bash'
227 alias python='PYTHONSTARTUP=~/.pythonrc.py python3'
228 alias webshare='python3 -mhttp.server'
229
230 if ! command -v pbcopy &> /dev/null; then
231 alias pbcopy='xsel --clipboard --input'
232 alias pbcopym='xsel --input'
233 alias pbpaste='xsel --clipboard --output'
234 alias pbpastem='xsel --output'
235 fi
236
237 # man with coloured headings and a terminal title
238 function man {
239 echo -ne "\\033]0;man $*\\007"
240
241 env \
242 LESS_TERMCAP_md=$'\E[01;38;5;74m' \
243 LESS_TERMCAP_me=$'\E[0m' \
244 LESS_TERMCAP_us=$'\E[04;38;5;146m' \
245 LESS_TERMCAP_ue=$'\E[0m' \
246 LC_CTYPE=C \
247 man "$@"
248 }
249
250 # Creates the directory if it doesn't exist, and changes into it
251 function mcd {
252 # shellcheck disable=SC2164
253 mkdir -p "$1" && cd "$1"
254 }
255
256 # Sets the nice and ionice priorities for the current shell to the lowest values
257 function slowshell {
258 ionice -c 3 -p $$
259 renice -n 19 -p $$
260 }
261
262 # SSH to an unknown host and print the new known_hosts entry
263 function ssh_new {
264 local new_known_hosts_file
265 new_known_hosts_file="$(mktemp)"
266 ssh -o UserKnownHostsFile="$new_known_hosts_file" "$@" echo 'Connection ok'
267 cat "$new_known_hosts_file"
268 rm -f "$new_known_hosts_file"
269 }
270
271 # SSH without verifying host key
272 function ssh_unsafe {
273 ssh -o StrictHostKeyChecking=no -o UserKnownHostsFile=/dev/null "$@"
274 }
275
276 ###########
277 # The end #
278 ###########
279
280 [ -r ~/.bashrc_local ] && source ~/.bashrc_local